#!/bin/sh

THISDIR=$(dirname "$(readlink -e "$0")")
cd "${THISDIR}"

JAVA=$(readlink -e "$(which java)")

# Calculate max{0.75 * physical_mem, 512} in MiB
TOTALMEM=$(grep MemTotal /proc/meminfo | tr -s ' ' | cut -d' ' -f2)
XMXMEM=$(($TOTALMEM * 3 / 4096))
XMXMEM=$([ $XMXMEM -gt 512 ] && echo $XMXMEM || echo 512)

if ! file -b $JAVA | grep -q x86-64 ; then
  XMXMEM=$([ $TOTALMEM -lt 2048 ] && echo $XMXMEM || echo 2047)
fi

$JAVA -Xms128m -Xmx${XMXMEM}m -jar bindiff.jar "$@"
